#include <memory.h>

.intel_syntax noprefix


.section .bss
.align PAGE_SIZE
.skip PAGE_SIZE
BootStack:

.section .text
.code32

.global _start
_start:

    cli

    // Temporary stack for booting
    mov esp, offset BootStack

    // Enable Page Address Extension
    mov eax, cr4
    or eax, 1<<5
    mov cr4, eax

    // Load Page Table (defined in boot/boot_PT.S)
    mov eax, offset BootP4
    mov cr3, eax

    // Enable Long Mode
    mov ecx, 0xC0000080
    rdmsr
    or eax, 1<<8
    wrmsr

    // Enable paging
    mov eax, cr0
    or eax, 1<<31
    mov cr0, eax

    // Load GDT (defined in cpu/gdt.c)
    lgdt [GDTp]

    // Jump into long mode
    jmp 0x8:long_mode_start

.code64
long_mode_start:

    // Clear out selectors
    mov eax, 0x0
    mov ss, eax
    mov ds, eax
    mov es, eax

    jmp $